import java.awt.*;
import freaklamarsch.awt.*;
import freaklamarsch.util.*;
/*
* ScrollPane to display some <code>Checkbox</code>es
* @author FReAK La Marsch
*/
public class CheckboxScrollPane extends FLMScrollPane
{
    private CheckboxPanel cp;

    /*CheckboxScrollPane()
    {
        super();
    }*/

    /*CheckboxScrollPane(int scrollbarDisplayPolicy)
    {
        super(scrollbarDisplayPolicy);
    }*/

    /*CheckboxScrollPane(String[] checkboxLabels, int scrollbarDisplayPolicy)
    {
        super(scrollbarDisplayPolicy, FLMScrollPane.NORTH_HORIZONTAL);
        cp = new CheckboxPanel(checkboxLabels);
        //addComponent(cp);
        replaceContent(cp);
    }*/

    /*CheckboxScrollPane(String[] checkboxLabels)
    {
        super(FLMScrollPane.NORTH_HORIZONTAL);
        cp = new CheckboxPanel(checkboxLabels);
        //addComponent(cp);
        replaceContent(cp);
    }*/

    CheckboxScrollPane(FLMResizableArray checkboxLabels, int scrollbarDisplayPolicy)
    {
        super(scrollbarDisplayPolicy, FLMScrollPane.NORTH_HORIZONTAL);
        cp = new CheckboxPanel(checkboxLabels);
        addComponent(cp);
    }

    /*CheckboxScrollPane(FLMResizableArray checkboxLabels)
    {
        super();
        cp = new CheckboxPanel(checkboxLabels);
        //addComponent(cp);
        replaceContent(cp);
    }*/

    public Component[] getComponents()
    {
        return cp.getComponents();
    }

    class CheckboxPanel extends Panel
    {
        public CheckboxPanel(String[] checkboxLabels)
        {
            setLayout(new GridLayout(checkboxLabels.length,1));
            for (int i=0; i<checkboxLabels.length; i++)
            {
                add(new Checkbox(checkboxLabels[i]));
            }
        }

        public CheckboxPanel(FLMResizableArray checkboxLabels)
        {
            setLayout(new GridLayout(checkboxLabels.size(),1));
            for (int i=0; i<checkboxLabels.size(); i++)
            {
                add(new Checkbox((String) checkboxLabels.get(i)));
            }
        }

        /**
        * Workaround for a Bug when Scrolbars are only displayed when needed.
        * When the horizontal Scrollbar was shown, it hid a part of the Viewport
        * @author FReAK La Marsch

        public Dimension getPreferredSize()
        {
        Dimension panelPreferredSize = super.getPreferredSize(); 
        //checks if the horizontal Scrollbar is displayed (this is when the panel is higher than the ScrollPane height - insets)
        return (panelPreferredSize.height > (getSize().height - getInsets().top * 2)) ? new Dimension(panelPreferredSize.width, panelPreferredSize.height + getHScrollbarHeight()) : super.getPreferredSize(); 
        } */
    }
} 
