package freaklamarsch.util;

import java.lang.*;
import java.lang.reflect.*;

/**
* Utility to get soem information about the system.
* @author FReAK La Marsch
*/
public class FLMSystemUtil
{
    /**
    * Checks if the System supports the Runtime.exec() command<br>
    */
    public static boolean canExec()
    {
        try
        {
            Method m = Runtime.getRuntime().getClass().getDeclaredMethod("execInternal", new Class[] {String[].class, String[].class, String.class});
        }
        catch(NoSuchMethodException nsme)
        {
            return false;
        }
        return true;
    }

    public static int activeThreadsCount()
    {
        ThreadGroup top = Thread.currentThread().getThreadGroup();
        while(true)
        {
            if (top.getParent() != null)
            {
                top = top.getParent();
            }
            else
            {
                break;
            }
        }
        System.out.println(top.activeCount());
        Thread[] theThreads = new Thread[top.activeCount()];
        top.enumerate(theThreads);
        for (int i = 0; i<theThreads.length; i++)
        {
            System.out.println(theThreads[i]);
        }
        return top.activeCount();
    }
}
